(function ($) {

Drupal.behaviors.imageeditor = {};
Drupal.behaviors.imageeditor.attach = function(context, settings) {
  //$.extend(true, Drupal.settings, settings);
  
  var $imageeditor_divs = $('.imageeditor', context);
  var $imageeditor_divs_existing = $('.imageeditor.imageeditor-existing', context);
  
  $imageeditor_divs.find('div.editors').find('div').click(
    function() {
      var tmp = $(this).attr('class').split(' ');
      var codename = tmp[0].replace(/-/g, '_');
      if (codename != 'aviary_feather') {
        var launch_type = Drupal.settings.imageeditor[codename]['launch_type'];
        var image_url_param = Drupal.settings.imageeditor[codename]['image_url_param'];
        var save_url_param = Drupal.settings.imageeditor[codename]['save_url_param'];
        var save_url_default = Drupal.settings.imageeditor[codename]['save_url_default'];
        var field_name = $(this).parent().parent().find('.field-name').attr('value');
        var delta = $(this).parent().parent().find('.delta').attr('value');
        var url = $(this).parent().parent().find('.url').attr('value');
        var options = Drupal.settings.imageeditor[codename].options;
        if (typeof(url) != 'undefined') {
          options[image_url_param] = url;
          options[save_url_param] = save_url_default + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1';
          if (codename == 'picnik') {options['_imageid'] = field_name + '_' + delta;}
        }
        else {
          delete options[image_url_param];
          options[save_url_param] = save_url_default + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1';
          if (codename == 'picnik') {delete options['_imageid'];}
        }
        Drupal.imageeditor[launch_type].show(options);
      }
    }
  );
  
  $imageeditor_divs_existing.find('div.aviary-feather').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor_first_run = 'yes';
      if (_featherLoaded) {
        aviaryeditor($(this).parent().parent().parent().parent().find('.image-preview').find('img').attr('id', field_name + '*' + delta).attr('id'), url);
      }
    }
  );
  
  $imageeditor_divs_existing.find('div.uploaders').find('div').click(
    function() {
      var tmp = $(this).attr('class').split(' ');
      var codename = tmp[0].replace(/-/g, '_');
      var $url = $(this).parent().parent().find('.url');
      var filepath = $(this).parent().parent().find('.filepath').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.imageeditor[codename].upload_url,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': filepath},
        success: function(data) {$url.attr('value', data);},
        error: function(msg) {alert("Failed uploading: " + msg);}
      });
    }
  );
  
  //to show as overlay over the image preview
  $('div.imageeditor-existing', context).each(
    function(index) {
      var field_name = $(this).find('.field-name').attr('value');
      if (Drupal.settings.imageeditor[field_name]['imageeditor_icons_position'] == 1) {
        $(this).parent().css({'position': 'relative', 'width': '100px'}).hover(
          function() {
            $(this).find('.imageeditor').css({'position': 'absolute', 'top': 0}).show();
          },
          function() {
            $(this).find('.imageeditor').hide();
          }
        ).find('.imageeditor').hide();
      }
    }
  );
};

var _featherLoaded = false;
Feather_OnLoad = function() {
    _featherLoaded = true;
};

Feather_OnSave = function(imageId, newurl) {
  imageeditor_url = newurl;
  if (imageeditor_first_run != 'no') {
    var tmp = imageId.split('*');
    imageeditor_field_name = tmp[0];
    imageeditor_delta = tmp[1];
    imageeditor_edit_field_name = 'edit-' + tmp[0].replace(/_/g, '-');
    if (Drupal.settings.imageeditor[imageeditor_field_name]['imageeditor_replace']) {
      $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-' + imageeditor_delta + '-remove-button"]').mousedown();
    }
    imageeditor_first_run = 'no';
  }
};

Feather_OnClose = function() {
  if ((typeof(imageeditor_field_name) != 'undefined') && (imageeditor_field_name != 'undefined')) {
    $('a[id^="' + imageeditor_edit_field_name + '-"][id$="-remote-source"]:first').click();
    $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-url"]:first').val(imageeditor_url);
    $('input[id^="' + imageeditor_edit_field_name + '-"][id$="-filefield-remote-transfer"]:first').mousedown();
    imageeditor_url = 'undefined';
    imageeditor_field_name = 'undefined';
    imageeditor_delta = 'undefined';
    imageeditor_edit_field_name = 'undefined';
    imageeditor_first_run = 'undefined';
  }
};

if (typeof(Drupal.imageeditor) == 'undefined') {
Drupal.imageeditor = function() {
  function windowSize() {
    var w = 0, h = 0;
    if(!(document.documentElement.clientWidth == 0)) {
      w = document.documentElement.clientWidth;
      h = document.documentElement.clientHeight;
    }
    else {
      w = document.body.clientWidth;
      h = document.body.clientHeight;
    }
    return {width:w,height:h};
  }
  function buildUrl(opt) {
    var url = opt.launch_url;
    var first_attr = 'yes';
    for (var attribute in opt) {
      if(attribute !== 'launch_url') {
        if (first_attr == 'yes') {
          url += "?"+ attribute +"="+ escape(opt[attribute]);
          first_attr = 'no';
        }
        else {
          url += "&"+ attribute +"="+ escape(opt[attribute]);
        }
      }
    }
    return url;
  }
  var bo = {
    ie: window.ActiveXObject,
    ie6: window.ActiveXObject && (document.implementation != null) && (document.implementation.hasFeature != null) && (window.XMLHttpRequest == null),
    quirks: document.compatMode==='BackCompat'
  };
  return {
    overlay: {
      show: function(options) {
        var iframe = document.createElement('iframe'),
        div = document.createElement('div'),
        idiv = document.createElement('div'),
        div_close = document.createElement('div');
        iframe.className = 'imageeditor-iframe';
        div.className = 'imageeditor-external';
        idiv.className = 'imageeditor-internal';
        div_close.className = 'imageeditor-close';
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          var size = windowSize();
          div.style.position = 'absolute';
          div.style.width = size.width + 'px';
          div.style.height = size.height + 'px';
          div.style.setExpression('top', "(t=document.documentElement.scrollTop||document.body.scrollTop)+'px'");
          div.style.setExpression('left', "(l=document.documentElement.scrollLeft||document.body.scrollLeft)+'px'");
        }
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          idiv.style.position = 'absolute';
          idiv.style.setExpression('top', "40+((t=document.documentElement.scrollTop||document.body.scrollTop))+'px'");
          idiv.style.setExpression('left', "40+((l=document.documentElement.scrollLeft||document.body.scrollLeft))+'px'");
        }
        
        document.body.appendChild(div);
        document.body.appendChild(idiv);
        document.body.appendChild(div_close);
        
        iframe.style.width = (div.offsetWidth - 80) +'px';
        iframe.style.height = (div.offsetHeight - 80) +'px';
        iframe.src = buildUrl(options);
        
        idiv.appendChild(iframe);
        
        $('div.imageeditor-close').click(
          function() {
            Drupal.imageeditor.overlay.hide();
          }
        );
      },
      hide: function() {
        $('.imageeditor-external').remove();
        $('.imageeditor-internal').remove();
        $('.imageeditor-close').remove();
      }
    },
    popup: {
      show: function(options) {
        popup_window = window.open(buildUrl(options), 'imageeditor', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no,channelmode=yes,fullscreen=yes');
        popup_window.focus();
      }
    }
  };
}();
}

})(jQuery);
